local self = AutoRoller

--  db[info[#info]]
local values =  {
   greed = "Greed",
   need = "Need",
   pass = "Pass",
   nothing = "Wait for Player"
}

function self:OptionGet(info)
   return self.db.profile[info[#info]]
end

function self:OptionSet(info, value)
   self.db.profile[info[#info]] = value
end

self.optionTable = {
   name = "Auto Roller",
   desc = "Automatically roll on items.",
   type = 'group',
   handler = self,
   get = 'OptionGet',
   set = 'OptionSet',
   args = {
      desc = {
         name = "Automatically roll on items.",
         type = 'description',
         order = 0,
      },
      enabled = {
         name = "Enabled",
         desc = "Enables / disables the addon",
         type = 'toggle',
         order = 1,
         get = 'IsEnabled',
         set = function (info, v)
            local self = info.handler
            self.db.profile.enabled = v
            if v then
               self:Enable()
            else
               self:Disable()
            end
         end,
      },
      chat = {
         name = "Chat Output",
         desc = "Output to chat when automatically rolling on an item.",
         type = 'toggle',
         order = 2,
         width = 'double',
      },
      boe = {
         name = "BoE",
         type = 'select',
         values = values,
         style = 'radio',
         order = 100,
      },
      bop = {
         name = "BoP",
         type = 'select',
         values = values,
         style = 'radio',
         order = 101,
      },
      recipe = {
         name = "Recipes",
         type = 'select',
         values = values,
         style = 'radio',
         order = 102,
      },
   }
}

--~ local ItemTypes = {"Armor", "Consumable", "Container", "Gem", "Key", "Miscellaneous", "Money", "Reagent", "Recipe", "Projectile", "Quest", "Quiver", "Trade Goods", "Weapon"}

--~ Armor = {"Miscellaneous", "Cloth", "Leather", "Mail", "Plate", "Shields", "Librams", "Idols", "Totems"

--~ Consumable = {"Food & Drink", "Potion", "Elixir", "Flask", "Bandage", "Item Enhancement", "Scroll", "Other", "Consumable"}

--~ Container = {"Bag", "Enchanting Bag", "Engineering Bag", "Gem Bag", "Herb Bag", "Mining Bag", "Soul Bag", "Leatherworking Bag"}

--~ Gem = {"Blue", "Green", "Orange", "Meta", "Prismatic", "Purple", "Red", "Simple", "Yellow"}

--~ Key = {"Key"}

--~ Miscellaneous = {"Junk", "Reagent", "Pet", "Holiday", "Mount", "Other"}

--~ Money

--~ Recipe = {"Alchemy", "Blacksmithing", "Book", "Cooking", "Enchanting", "Engineering", "First Aid", "Leatherworking", "Tailoring"}

--~ Projectile = {"Arrow", "Bullet"}

--~ Quest = {"Quest"}

--~ Quiver = {"Ammo Pouch", "Quiver"}

--~ Trade Goods = {"Armor Enchantment", "Cloth", "Devices", "Elemental", "Enchanting", "Explosives", "Herb", "Jewelcrafting", "Leather", "Materials", "Meat", "Metal & Stone", "Other", "Parts", "Trade Goods", "Weapon Enchantment"}

--~ Weapon = {"Bows", "Crossbows", "Daggers", "Guns", "Fishing Poles", "Fist Weapons", "Miscellaneous", "One-Handed Axes", "One-Handed Maces", "One-Handed Swords", "Polearms", "Staves", "Thrown", "Two-Handed Axes", "Two-Handed Maces", "Two-Handed Swords", "Wands", "One-Hand", "Two-Hand"}

function self:RegisterOptions()
   local options = self.optionTable
   local profile = LibStub('AceDBOptions-3.0'):GetOptionsTable(self.db)

   local registry = LibStub('AceConfigRegistry-3.0')
   local dialog = LibStub('AceConfigDialog-3.0')
   LibStub('AceConfig-3.0'):RegisterOptionsTable('AutoRoller', options, 'autoroller')

	registry:RegisterOptionsTable('AutoRoller Options', options)
	registry:RegisterOptionsTable('AutoRoller Profiles', profile)

   local main = dialog:AddToBlizOptions('AutoRoller Options', 'AutoRoller')
   self.optionsFrames = {
      main = main,
		profiles = dialog:AddToBlizOptions('AutoRoller Profiles', 'Profiles', 'AutoRoller'),
   }

   if self.dataobj then
      self.dataobj.OnClick = function() InterfaceOptionsFrame_OpenToCategory(main) end
   end
end